# Create Supernet

Please download the [juneojs-examples](https://github.com/Juneo-io/juneojs-examples) repository on your local machine. If you have [git](https://git-scm.com/) installed on your system, please execute the following in your command line:

```
git clone https://github.com/Juneo-io/juneojs-examples
```

The required files will be found in the directory `juneojs-examples`.

Next, please open `juneojs-examples` in a command line and execute the following command:

```
npm install
```

After this, open `juneojs-examples` in a code editor of your choice, create a .env file from the provided .env.example, and paste your mnemonic phrase in the MNEMONIC variable. Example:

```
MNEMONIC="raven whip pave toy benefit moment twin acid wasp satisfy crash april"
```

To perform the transactions required to deploy a Supernet, you will need to have funds on the P-chain.  In this tutorial, we will first be crossing assets from the JUNE-chain to the JVM-chain, and then from  the JVM-chain to the P-chain.

In a command line window open in the root of the JuneoJS library, execute the following:

```
npx ts-node ./src/docs/crossJUNEtoJVM.ts
```

This will cross 1.1 JUNE from the JUNE-chain to the JVM-chain. After this, we will cross 1 JUNE from the JVM-chain to the P-chain by executing the following command:

```
npx ts-node ./src/docs/crossJVMtoP.ts
```

The next step is the Supernet creation. Please execute the following in the comand line:

```
npx ts-node ./src/supernet/createSupernet.ts
```

This will produce an output to the terminal containing your supernetID. Example: *ZxTjijy4iNthRzuFFzMH5RS2BgJemYxwgZbzqzEhZJWqSnwh.*

This is the id of the transaction that has created your Supernet, and is the id of the Supernet as well. Please save it as we will needed in the following steps.

### Add a validator to the Supernet

The next step is to perform the addSupernetValidator transaction.

{% hint style="info" %}
If your Supernet has no validators, all blockchains in that Supernet will be inactive and will not be able to process transactions.
{% endhint %}

Please open the file `./src/supernet/addSupernetValidator.ts` in your code editor, and update the following variables to contain the correct values. Example:

```
const nodeId: string = 'NodeID-B2GHMQ8GF6FyrvmPUX6miaGeuVLH9UwHr'
const supernetId: string = 'ZxTjijy4iNthRzuFFzMH5RS2BgJemYxwgZbzqzEhZJWqSnwhP'
const durationInDays: number = 4 // number of days you will validate your Supernet
```

We will keep the **durationInDays** variable the same. However, you may update it to a diffent value.

{% hint style="info" %}
The variable **durationInDays** must be less than the amount of remaining days your node will be validating the Primary network.<br>

If your node has 5 days (or a little over 4 days) left of Primary Network validation, you must set **durationInDays** to 4 or less.
{% endhint %}

Then, execute this file:

```
npx ts-node ./src/supernet/addSupernetValidator.ts
```

This will add our node as a validator for our supernet. However, we need to perform an additional step before our node can begin validating our Supernet. First, please stop your node.

For users following the [manual ](broken://pages/8wCmuDprLmpqHNt5EwnG)guide for setting up juneogo: please create a file titled `config.json` in the home directory.&#x20;

For users following the [install script](broken://pages/CCnlAB301M6pyPPdy4p4) guide for setting up juneogo: your `config.json` can already be found in the home directory.&#x20;

For users who are running juneogo using [juneogo-docker](https://github.com/Juneo-io/juneogo-docker): your config file can be found in the `juneogo-docker/juneogo/.juneogo/config.json` directory.

In your `config.json` file, please include the configuration flag `track-supernets,` specifying the Supernets you want your node to track (in this case, the Supernet you have just created).

Example:

```
{
 "track-supernets":"ZxTjijy4iNthRzuFFzMH5RS2BgJemYxwgZbzqzEhZJWqSnwhP"
}
```

After saving the file, you may run your node again.&#x20;

For users following the [manual ](broken://pages/8wCmuDprLmpqHNt5EwnG)juneogo setup guide, please execute the following :

```
./juneogo --config-file="./config.json"
```

For users following the [install script](broken://pages/CCnlAB301M6pyPPdy4p4) juneogo setup guide, please restart the juneogo service:

```
systemctl --user restart juneogo.service
```

For users running juneogo using [juneogo-docker](https://github.com/Juneo-io/juneogo-docker), please re-start your node using docker compose.

Your node is now tracking the Supernet you have just created.&#x20;

{% hint style="info" %}
If **your node** is the only node validating your Supernet - once your node stops validating it, all chains within it will not be able to process transactions.\
\
You would have to re-perform the **Add Supernet Validator** transaction for your Supernet's chains to process transactions again.
{% endhint %}

You may now proceed to the next step: [Deploy a VM](broken://pages/aVPFJQZplrtkf4b1LLeA).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.logosnodos.online/testnet-node/juneo-network/create-supernet.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
